IGP Extensions for Advertising Node Index
Huaimo Chen
Independent
Boston, MA
USA
hchen.ietf@gmail.com
Donald E. Eastlake 3rd
Independent
2386 Panoramic Circle
Apopka, FL
32703
USA
+1-508-333-2270
d3e3e3@gmail.com
Aijun Wang
China Telecom
Beiqijia Town, Changping District
Beijing
102209
China
wangaj3@chinatelecom.cn
Gyan S. Mishra
Verizon Inc.
13101 Columbia Pike
Silver Spring
MD 20904
USA
301 502-1347
gyan.s.mishra@verizon.com
Yisong Liu
China Mobile
liuyisong@chinamobile.com
Yanhe Fan
Casa Systems
USA
yfan@casa-systems.com
Lei Liu
Fujitsu
USA
liulei.kddi@gmail.com
Xufeng Liu
Alef Edge
USA
xufeng.liu.ietf@gmail.com
24 september 2024
This document describes OSPF and IS-IS extensions for distributing the node index configured on a node.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
When the nodes in a network are numbered or indexed from 1 to the number of the nodes, an efficient stateless multicast along the shortest paths to the egresses of a P2MP tree can be achieved using the node indices of the egresses.
This document proposes OSPF and IS-IS extensions for distributing the node index configured on a node to support the best effort stateless multicast.
When a controller such as PCE as a controller has the node indexes, it can send the P2MP tree encoded in the node indexes to the ingress of the tree.

Terminology
LSA: Link State Advertisement.
OSPF: Open Shortest Path First.
LSP: Link State Protocol data unit.
IS-IS: Intermediate System to Intermediate System.

Extensions to OSPF
This section describes extensions to OSPF for distributing the node index configured on a node. The node index of a node MUST be unique in a network. This is like the identifier (ID) of the node.
[RFC7770] defines the Router Information (RI) Link state Advertisement (LSA). The RI LSA is used to advertise Optional Router Information using Router Information LSA TLVs.
A new Router Information LSA TLV, called Node Index TLV, is defined to carry the Node Index configured on the node originating the RI LSA.
The Node Index TLV has the following format:

Node Index TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type (TBD1)          |           Length (2)          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |            Node Index         |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: TBD1.
Length: 2.
Node Index: The node index configured on a node.
This TLV is optional. It is applicable to both OSPFv2 and OSPFv3. For advertising a node index, the area-scoped RI LSA including a Node Index TLV is used.

Extension to IS-IS
This section describes an extension to IS-IS for distributing the Node Index configured on a node.
[RFC7981] defines the IS-IS Router CAPABILITY TLV to advertise Router Information. The TLV includes multiple sub-TLVs.
A new Node Index sub-TLV to be included in the TLV, is defined to carry the Node Index configured on the node originating the TLV in its LSP.
This sub-TLV has the following format:

Node Index sub-TLV

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  Type (TBD2)  |   Length (2)  |           Node Index          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type: TBD2.
Length: 2.
Node Index: The Node Index configured on a node.
This sub-TLV is optional. For advertising a node index, the area-scoped LSP including a Node Index sub-TLV in an IS-IS Router CAPABILITY TLV is used.

Security Considerations
TBD.

IANA Considerations

OSPF RI TLVs Registry
Under "OSPF Router Information (RI) TLVs registry" as defined in [RFC7770], IANA is requested to assign a new type as follows:

  +==============+===================+=====================+
  |  Value       |  Description      |    reference        |
  +==============+===================+=====================+
  |  TBD1        |  Node Index       |    This document    |
  +--------------+-------------------+---------------------+

IS-IS Sub-TLVs for TLV 242 Registry
Under "Sub-TLVs for TLV 242 (IS-IS Router CAPABILITY TLV) registry" as defined in [RFC7981], IANA is requested to assign a new sub-TLV as follows:

  +==============+===================+=====================+
  |  Value       |  Description      |    reference        |
  +==============+===================+=====================+
  |  TBD2        |  Node Index       |    This document    |
  +--------------+-------------------+---------------------+

Acknowledgements
The authors would like to thank people for their comments on this work.

Normative References
[RFC2119]
[RFC8174]
[RFC7770]
[RFC7981]